% !TeX TS-program = xelatex
%Copyright 2019 Pierre-Antoine Rault

%Based on a template by Jean-Philippe Eisenbarth, and distributed under
%the GPLv3-only license as follows:
%This program is free software: you can 
%redistribute it and/or modify it under the terms of the GNU General Public 
%License as published by the Free Software Foundation, either version 3 of the 
%License, or (at your option) any later version.
%This program is distributed in the hope that it will be useful,but WITHOUT ANY 
%WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
%PARTICULAR PURPOSE. See the GNU General Public License for more details.
%You should have received a copy of the GNU General Public License along with 
%this program.  If not, see <http://www.gnu.org/licenses/>.

%Based on the code of Yiannis Lazarides
%http://tex.stackexchange.com/questions/42602/software-requirements-specification-with-latex
%http://tex.stackexchange.com/users/963/yiannis-lazarides
%Also based on the template of Karl E. Wiegers
%http://www.se.rit.edu/~emad/teaching/slides/srs_template_sep14.pdf
%http://karlwiegers.com

\documentclass[tikz]{scrreprt}
\usepackage{listings}
\usepackage{underscore}
\usepackage{color}
\definecolor{darkblue}{rgb}{0.0,0.0,0.3}
\usepackage[bookmarks=true]{hyperref}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[libertine]{newtxmath} % loads linux libertine font
\usepackage[english]{babel}
\usepackage{pdfpages}
\hypersetup{
    bookmarks=false,    % show bookmarks bar?
    pdftitle={Software Requirement Specification},    % title
    pdfauthor={Pierre-Antoine Rault},                     % author
    pdfsubject={OLKi platform},                        % subject of the document
    pdfkeywords={specification, OLKi, federation}, % list of keywords
    colorlinks=true,       % false: boxed links; true: colored links
    linkcolor=blue,       % color of internal links
    citecolor=black,       % color of links to bibliography
    filecolor=black,        % color of file links
    urlcolor=darkblue,        % color of external links
    linktoc=page            % only page is linked
}%
\usepackage[inline]{enumitem}
\usepackage{amssymb}
\def\myversion{1.0}
\date{}
%\title{%



%}

\newlist{todolist}{itemize}{2}
\setlist[todolist]{label=$\square$}
\usepackage{pifont}
\newcommand{\cmark}{\ding{51}}%
\newcommand{\xmark}{\ding{55}}%
\newcommand{\done}{\rlap{$\square$}{\raisebox{2pt}{\large\hspace{1pt}\cmark}}%
	\hspace{-2.5pt}}
\newcommand{\wontfix}{\rlap{$\square$}{\large\hspace{1pt}\xmark}}

\usepackage{hyperref}
\usepackage{graphicx}
\graphicspath{{graphics/}}
\usepackage{times}
\usepackage[]{minted}
\usepackage{fontspec}
\usepackage{xunicode}
\usepackage{inconsolata}
\setmonofont{inconsolata}
\setminted[json]{tabsize=2,fontsize=\small,breaklines}
\usepackage{tcolorbox}
\usepackage{etoolbox}
\BeforeBeginEnvironment{minted}{\begin{tcolorbox}}%
\AfterEndEnvironment{minted}{\end{tcolorbox}}%
\usepackage{tikz}
\usetikzlibrary{matrix}

\colorlet{helpful}{lime!70}
\colorlet{harmful}{red!30}
\colorlet{internal}{yellow!20}
\colorlet{external}{cyan!30}
\colorlet{S}{helpful!50!internal}
\colorlet{W}{harmful!50!internal}
\colorlet{O}{helpful!50!external}
\colorlet{T}{harmful!50!external}

\newcommand{\texta}{Helpful\\ \tiny (to achieve the objective)\par}
\newcommand{\textb}{Harmful\\ \tiny (to achieve the objective)\par}
\newcommand{\textcn}{Internal origin\\ \tiny (product\slash software attributes)\par}
\newcommand{\textdn}{External origin\\ \tiny (environmental attributes)\par}

\newcommand{\back}[1]{\fontsize{60}{70}\selectfont #1}

\renewenvironment{dedication}
{\vspace{10cm}\begin{quotation}\begin{flushright}\begin{em}}
			{\par\end{em}\end{flushright}\end{quotation}}

\urlstyle{same}

\usepackage{datatool}% http://ctan.org/pkg/datatool
\newcommand{\sortitem}[2][\relax]{%
	\DTLnewrow{list}% Create a new entry
	\ifx#1\relax
	\DTLnewdbentry{list}{sortlabel}{#2}% Add entry sortlabel (no optional argument)
	\else
	\DTLnewdbentry{list}{sortlabel}{#1}% Add entry sortlabel (optional argument)
	\fi%
	\DTLnewdbentry{list}{description}{#2}% Add entry description
}
\newenvironment{sortedlist}{%
	\DTLifdbexists{list}{\DTLcleardb{list}}{\DTLnewdb{list}}% Create new/discard old list
}{%
	\DTLsort{sortlabel}{list}% Sort list
	\begin{itemize}%
		\DTLforeach*{list}{\theDesc=description}{%
			\item \theDesc}% Print each item
	\end{itemize}%
}

\setlength\parindent{.2cm}

\begin{document}

\includepdf[pages=-]{../initial-report/report.pdf}

\begin{flushright}
\thispagestyle{empty}
    \rule{16cm}{5pt}\vskip1cm
    \begin{bfseries}
        \sffamily
        \Huge{SOFTWARE REQUIREMENTS\\ SPECIFICATION}\\
        \vspace{1.9cm}
        for\\
        \vspace{1.9cm}
        the OLKi platform\\
        \vspace{1.9cm}
        \LARGE{Version \myversion}\\
        \vspace{1.9cm}
        Prepared by Pierre-Antoine Rault\\
        \vspace{1.9cm}
        LORIA\\
        \vspace{1.9cm}
        \today\\
    \end{bfseries}
\end{flushright}

\begin{dedication}
\thispagestyle{empty}
\vspace*{6cm}
	"For Artists and Hackers, Academics, and Admins.
	For Humans who Grok stuff. Those self taught, and persistent.
	For those who build \emph{for Us}: Tools to own and run.
	For People in Community: Who will \emph{not} be a Commodity,
	For Our Internet, And all who sail on her.
	Useful may it be. Save time may it much."
	
	\vspace{\baselineskip}
	\textsc{\textsf
	Peter Gossner, October 2018, Fediverse Glossary
	}
\end{dedication}

\tableofcontents

\chapter*{Revision History}

\begin{center}
    \begin{tabular}{|c|c|c|c|}
        \hline
        Name & Date & Reason For Changes & Version\\
        \hline
        P-A. Rault & march 19, 2019 & initial version & 0.1\\
        \hline
    \end{tabular}
\end{center}

\chapter{Introduction}

\section{Purpose}

The present document specifies parts of a computer system, hereinafter called "OLKi platform" or "platform", as well as the distribution services that might be added to it, and the ecosystem of federated platforms that it wishes to integrate with. 

The platform is a web service intended to run on a standard tiered server: behind a web server, and associated with a database and cache system. The parts of the platform that are discussed in this document cover both its web client and its server runtime.

The first release of the platform is projected to have the version number 1.0. This document describes its functionality.

\section{Document Conventions}

%$<$Describe any standards or typographical conventions that were followed when 
%writing this SRS, such as fonts or highlighting that have special significance.  
%For example, state whether priorities  for higher-level requirements are assumed 
%to be inherited by detailed requirements, or whether every requirement statement 
%is to have its own priority.$>$

Defined terms are highlighted with \textbf{bolding}. Requirements will come with priority to indicate in which order they will be implemented. Versions might be released with only some of the total list of requirements implemented.

\section{Intended Audience and Reading Suggestions}

%$<$Describe the different types of reader that the document is intended for, 
%such as developers, project managers, marketing staff, users, testers, and 
%documentation writers. Describe what the rest of this SRS contains and how it is 
%organized. Suggest a sequence for reading the document, beginning with the 
%overview sections and proceeding through the sections that are most pertinent to 
%each reader type.$>$

The present document is mostly describing the technical requirements, and as such is intended for developers and system administrators (system administrators can directly go to the Deployment Requirements section \ref{sec:deployment} page \pageref{sec:deployment} for notes specific to their mission).

While most concepts are explained on first use, a prior knowledge of what a tiered application is\footnote{\url{https://12factor.net}}, what the \textbf{fediverse} is\footnote{\url{https://fediverse.gitlab.io/en/fediverse}}, and what platforms we already surveyed in our initial reports\footnote{\url{https://framagit.org/synalp/olki/documents/initial-report/releases}} is advised.

\section{Project Scope}
%$<$Provide a short description of the software being specified and its purpose, 
%including relevant benefits, objectives, and goals. Relate the software to 
%corporate goals or business strategies. If a separate vision and scope document 
%is available, refer to it rather than duplicating its contents here.$>$

In a time of increasing distrust and defiance of citizens towards artificial intelligence, the scientific community is not left untainted by the recent scandals and must provide an answer to a justified concern of the society. OLKi wants to take part in that næscent effort by ensuring datasets and particularly linguistic datasets that are the essential resource of machine learning techniques can be easily hosted and interacted with for the whole scientific community, with the twofold objective of transparency and understandability of research data.

The OLKi project will connect researchers, scientists and citizens through the Fediverse. To do so it will extend the ActivityStreams language to support scientific research datasets and their related activities for the web, and create the OLKi platform to feature it.

The Fediverse is originally a social-network-oriented text communication platform that has emerged as a citizen initiative in 2017. It has quickly grown, both in number of users (more than 2.5 million users in November 2018) and supported functionalities, including for instance blog-like platforms (Plume), image sharing (Pixelfed), video sharing (PeerTube), audio sharing (funkwhale), etc. all while maintaining the basics for compatibility and interoperability (Pleroma being one of the main examples). One of the main strengths of the Fediverse is that all of these features are interconnected together through open standards, enabling users of one feature to access other features as well. A major side-effect is that web applications don't have to compete with each other but can understand each other (with a degree of compatibility). It might seem insignificant since it just amounts to the classic gains of using open standards. However in the case of social interactions, it allows even small and novel software to free themselves from Metcalfe's law by gaining support from existing communities.

The OLKi project will further enhance the Fediverse with a new functionality oriented towards scientific communication and research results dissemination. This will fill the current need of a dedicated global and open communication platform between researchers, but also between scientists and citizens. A need that is currently (partially) covered by sites such as Twitter or ResearchGate, although we argue they are unfit for the role. In that sense it will be more than a platform to host datasets and provide features that current dataset hosting platforms lack.

\section{Project Deliverables}

The OLKi platform will release:

\begin{itemize}
	\item a landing page and technical blog, already available at \url{https://olki.loria.fr/platform/}
	\item a project account for announces on Mastodon, already available at\\ \url{https://mastodon.etalab.gouv.fr/@scifed}
	\item a complete source of its software(s)
	\item a pre-compile frontend if need be for ease of deployment
	\item a \verb|.deb| compatible with Debian stable
	\item a YunoHost definition for YunoHost support (using the previously defined \verb|.deb|)
	\item a Docker image based on Debian stable (using the previously defined \verb|.deb|)
\end{itemize}

\section{References}
%$<$List any other documents or Web addresses to which this SRS refers. These may 
%include user interface style guides, contracts, standards, system requirements 
%specifications, use case documents, or a vision and scope document. Provide 
%enough information so that the reader could access a copy of each reference, 
%including title, author, version number, date, and source or location.$>$

%TODO: name before links

The present document refers to multiple documents that the reader might want to be familiar with:

\begin{itemize}
	\item \url{https://webfinger.net/ and www.rfc-editor.org/rfc/rfc7033.txt}
	\item \url{https://www.w3.org/TR/activitypub/}
	\item \url{https://www.w3.org/TR/activitystreams-vocabulary/}
	\item \url{https://www.w3.org/TR/activitystreams-core/}
	\item \url{http://www.openarchives.org/OAI/openarchivesprotocol.html}
	\item \url{http://microformats.org/wiki/dry}
	\item \url{https://indieweb.org/principles}
	\item \url{https://tools.ietf.org/html/rfc5785} or \url{https://www.iana.org/assignments/well-known-uris/well-known-uris.xhtml}
	\item \url{http://www.rssboard.org/rss-specification}
	\item \url{https://www.w3.org/annotation/} and its refinement \url{https://www.w3.org/TR/wpub-ann/}\\\url{https://w3c.github.io/web-annotation/selector-note/index-respec.html\#FragmentSelector_def} is also extremely important.
	\item \url{https://www.w3.org/TR/ldn/}
	\item \url{https://tools.ietf.org/html/rfc7089}
	\item \url{https://12factor.net/}
	\item \url{https://www.divio.com/blog/documentation/}
	\item \url{https://json-ld.org/}
	\item \url{https://w3c-dvcg.github.io/ld-signatures/}
	\item \url{https://graphql.org/}
	\item \url{https://opensocial.github.io/spec/2.0.1/Social-API-Server.xml\#ActivityStreams-Service}
	\item \url{http://robustlinks.mementoweb.org/}
	\item \url{https://oauth.net/}
	\item \url{http://microformats.org/wiki/rfc-2119}
	\item \url{http://dev.opml.org/}
	\item \url{https://www.w3.org/RDF/}
	\item \url{https://www.w3.org/TR/webmention/}
	\item \url{http://stateless.co/hal\_specification.html}
\end{itemize}

The following are related to general design and/or UX:

\begin{itemize}
	\item \url{https://2017.ind.ie/ethical-design/}
	\item \url{https://www.w3.org/WAI/standards-guidelines/wcag/}
	\item \url{https://ometer.com/free-software-ui.html}
\end{itemize}

The following are related to diffusion protocols that might be used at a later stage:

\begin{itemize}
	\item \url{https://datprotocol.github.io/how-dat-works/}
\end{itemize}

The following are related platforms that feature some of the previously cited technologies:

\begin{itemize}
	\item \url{https://web.hypothes.is/}
	\item \url{https://zenodo.org/}
	\item \url{http://www.meta-net.eu/meta-share/architecture}
	\item \url{https://academictorrents.com/}
\end{itemize}

\chapter{Overall Description}

\section{Product Perspective}
%$<$Describe the context and origin of the product being specified in this SRS.  
%For example, state whether this product is a follow-on member of a product 
%family, a replacement for certain existing systems, or a new, self-contained 
%product. If the SRS defines a component of a larger system, relate the 
%requirements of the larger system to the functionality of this software and 
%identify interfaces between the two. A simple diagram that shows the major 
%components of the overall system, subsystem interconnections, and external 
%interfaces can be helpful.$>$

The need for a scientific platform like OLKi arises with the ever increasing use of social platforms by both researchers and citizens in general, in spite of their lack of scientific tools. The OLKi platform aims to close that gap, and allow everyone on open social networks to benefit from tools that matter when discussing around research material but more generally any corpora complex enough to require targeted annotation and referencing.

A common example is for paper reviews to be made in the form of Twitter threads with image captures text passages, or Reddit threads discussing the publication of a corpus. Mixed populations answer and bring value to the discussion, but more than that they take part in the most accessible form of vulgarisation. This allows to bring people closer to the scientific material itself, a necessary thing especially at times when the outcome of a research can quickly get overblown if one is only reading the abstract - or worse its retranscription on TV. 

We argue the need is even more urging when it comes to machine learing: announces prophetising strong AI and their consequences are made daily and their form doesn't allow the proper hindsight to judge of their pertinence or react with anything but fear, lest enough of their content is available for review by everyone. OLKi takes that mission to build bridges between traditional scientific platforms and their content, and traditional social networks, so that science is not anymore a distant reverie only accessible to scientists.

\section{Product Functions}\label{sec:functions}
%$<$Summarize the major functions the product must perform or must let the user 
%perform. Details will be provided in Section 3, so only a high level summary 
%(such as a bullet list) is needed here. Organize the functions to make them 
%understandable to any reader of the SRS. A picture of the major groups of 
%related requirements and how they relate, such as a top level data flow diagram 
%or object class diagram, is often effective.$>$

OLKi takes its root in an environment where data and algorithm replicability is key to understanding, and the platform will be no different. All of its functions will base off open source and open standards. The resulting platform itself will be libre, free software. The social and scientific platforms OLKi interacts with will also have to be open or at least give an open API.

\bigskip

Basic functions of OLKi amount to indexing content uploaded by its users in the form of research corpora (any document, text or dataset).

\begin{itemize}
	\item This content is indexed and searcheable. Other content of the same type (corpora) originating from federating servers will also be indexed and searcheable (see how OLKi federates and how OLKi displays content). Other content harvested (scraped) from ArXiV and HAL will also be indexed and searcheable.
	\item This content is uploaded by trusted users freely, or else it goes through a "pending review" from a moderator or administrator of the server before going public.
	\item This content can be interacted with via a rich comment (regular \textit{Note} comment with additional annotation syntaxes) freely or only by chosen accounts. 
	\item Accounts, IPs and full domains can be banned of interacting by an instance administrator or at the account level. Since having content to reference can quickly turn into a heavy moderation task, 
\end{itemize}

\subsection*{Content discovery}

\textit{Foreword}: content discovery is important in any platform. It drives the relationship with most platforms, and is often presented first to the user. OLKi is no different, and content discovery plays a big role in some of the use cases/features later detailed in chapter \ref{ch:features}. We thus have to make assumptions as to how users will apprehend the OLKi platform when coming to the main page, detailed below.

\bigskip

\noindent\makebox[\textwidth]{%
\begin{tikzpicture}
	\node[anchor=south west,inner sep=0] (image) at (0,0,0) {\includegraphics[width=0.3\textwidth]{GLOBALVIEW.png}};
	\begin{scope}[x={(image.south east)},y={(image.north west)}]
	%% next four lines will help you to locate the point needed by forming a grid. comment these four lines in the final picture.↓
	%      \draw[help lines,xstep=.1,ystep=.1] (0,0) grid (1,1);
	%        \draw[help lines,xstep=.05,ystep=.05] (0,0) grid (1,1);
	%        \foreach \x in {0,1,...,9} { \node [anchor=north] at (\x/10,0) {0.\x}; }
	%        \foreach \y in {0,1,...,9} { \node [anchor=east] at (0,\y/10) {0.\y};}
	%% upto here↑
	\draw[dashed,-latex] (0.8,0.8) -- +(1in,0.2in)node[anchor=west] {current view options};
	\draw[dashed,-latex] (0.5,0.6) -- +(1.5in,0)node[anchor=west] {list of corpora};
	\draw[dashed,-latex] (0.5,0.05) -- +(-1.5in,0)node[anchor=east] {pagination};
	\draw[dashed,-latex] (0.2,0.74) -- +(-1in,-0.2in)node[anchor=east] {navigate between views};
	\end{scope}
\end{tikzpicture}
}

\bigskip

Instances are assumed to be hosting content of a group of researchers. Their work cover a limited number of topics that will be chosen by the instance administrator as being "representative" of the "focus" of an instance's users. This will impact the listing of content displayed by default in the general listing of all content. By "general content", we mean a listing that mixes \textbf{local}, \textbf{federated} and \textbf{harvested} content. Let us call this listing "Global view". As opposed to a "Personal view" that lists only persons/groups you follow as a user and that is only available when logged-in, the "Global view" lists corpora that can be seen from the point of view of the server, but filtered down to the selected set of topics of focus of the instance. It gives an insight of what is accessible for review to \textbf{users} and \textbf{visitors} alike.

\bigskip

Local content is favored in the display with reserved spaces when possible, and filtering options allow to show local content only. A dedicated view listing local research teams wishing to be listed is available as another view. This ensures an instance of OLKi can be used by its users to showcase their work.

\subsection*{User and Teams profiles}

Users have a profile with a name, picture, description, and list of works (corpora). They can constitute Teams which also have a name, picture and description. Teams are groups of local users that by default do not show any information but the corpora and members its members wish to showcase.

\subsection*{Corpus page and interaction mechanics}

Opening a corpus switches to a view ($\approx$ page) split in two panes: on the left the title, description, metadata and list of files, and on the right a pane listing/suggesting interactions with the corpus (for instance comments, statistics about the data, etc.).

\bigskip

\noindent\makebox[\textwidth]{%
	\begin{tikzpicture}
	\node[anchor=south west,inner sep=0] (image) at (0,0,0) {\includegraphics[width=0.3\textwidth]{CORPUS.png}};
	\begin{scope}[x={(image.south east)},y={(image.north west)}]
	%% next four lines will help you to locate the point needed by forming a grid. comment these four lines in the final picture.↓
%	      \draw[help lines,xstep=.1,ystep=.1] (0,0) grid (1,1);
%	        \draw[help lines,xstep=.05,ystep=.05] (0,0) grid (1,1);
%	        \foreach \x in {0,1,...,9} { \node [anchor=north] at (\x/10,0) {0.\x}; }
%	        \foreach \y in {0,1,...,9} { \node [anchor=east] at (0,\y/10) {0.\y};}
	%% upto here↑
	\draw[dashed,-latex] (0.7,0.6) -- +(1in,0)node[anchor=west] {comments, reviews};
	\draw[dashed,-latex] (0.2,0.6) -- +(-1in,0in)node[anchor=east] {corpus photo, metadata};
	\draw[dashed,-latex] (0.2,0.4) -- +(-1in,0in)node[anchor=east] {list of files};
	\end{scope}
	\end{tikzpicture}
}

\subsection*{Navigation}

\noindent\makebox[\textwidth]{%
	\begin{tikzpicture}
	\node[anchor=south west,inner sep=0] (image) at (0,0,0) {\includegraphics[width=1.2\textwidth]{navigation-olki.png}};
	\begin{scope}[x={(image.south east)},y={(image.north west)}]
	%% next four lines will help you to locate the point needed by forming a grid. comment these four lines in the final picture.↓
%	      \draw[help lines,xstep=.1,ystep=.1] (0,0) grid (1,1);
%	        \draw[help lines,xstep=.05,ystep=.05] (0,0) grid (1,1);
%	        \foreach \x in {0,1,...,9} { \node [anchor=north] at (\x/10,0) {0.\x}; }
%	        \foreach \y in {0,1,...,9} { \node [anchor=east] at (0,\y/10) {0.\y};}
	%% upto here↑
	\draw[dashed,-latex] (0.15,0.5) -- +(0,-0.5in)node[anchor=north] {view navigation};
	\draw[dashed,-latex] (0.5,0.5) -- +(0,-0.5in)node[anchor=north] {login/notifications};
	\draw[dashed,-latex] (0.85,0.5) -- +(0,-0.5in)node[anchor=north] {current view actions};
	\end{scope}
	\end{tikzpicture}
}

\section{User Classes and Characteristics}
%$<$Identify the various user classes that you anticipate will use this product.  
%User classes may be differentiated based on frequency of use, subset of product 
%functions used, technical expertise, security or privilege levels, educational 
%level, or experience. Describe the pertinent characteristics of each user class.  
%Certain requirements may pertain only to certain user classes. Distinguish the 
%most important user classes for this product from those who are less important 
%to satisfy.$>$

The OLKi platform pertains to the needs of the following initial user populations (which incidentally are the classes of users corresponding to each scientific group involved in the OLKi project - from the point of view of their usage later identified in the use cases in chapter \ref{ch:features}, page \pageref{ch:features}):

\begin{enumerate}
	\item general computer science researchers
	\item machine learning researchers
	\item natural language processing researchers
	\item researchers in epistemology
	\item researchers in linguistic
	\item researchers in mathematics
\end{enumerate}

We note computer science researchers often have less use for a platform to host corpora when most of their data amounts to code that is already hosted on dedicated software forges (web-based collaborative software platform for both developing and sharing computer applications). They will be more interested in scientific watch features.

\bigskip

Other classes of users might be later taken into account, but for now we will only count citizens in general. We consider they won't bother creating an account on the platform for a single review (especially since instances will be institutional and closed to registrations at first) but still might want to reference or annotate documents. Users not creating an account can still interact with the public features of the platform ; they are called \textbf{visitors}.

\section{Operating Environment}

%$<$Describe the environment in which the software will operate, including the 
%hardware platform, operating system and versions, and any other software 
%components or applications with which it must peacefully coexist.$>$

The platform is meant to be run on small to medium servers, as can be typically found in most virtual private server providers' offers. It requires to run more than a simple web server but also a runtime of the selected language. Typical shared hosting with no possibility to run anything beside PHP behind a web server will prevent running the platform, and deployment cannot be expected to be done with just copying files via FTP.

The runtime will expect existence of a PostgreSQL database running locally and accessible via socket or local TCP connection, as well a Redis service under the same circumstances.

The runtime will bind on the loopback interface only, and on a configurable port. It is expected the system administrator configures 

\section{Design and Implementation Constraints}
%$<$Describe any items or issues that will limit the options available to the 
%developers. These might include: corporate or regulatory policies; hardware 
%limitations (timing requirements, memory requirements); interfaces to other 
%applications; specific technologies, tools, and databases to be used; parallel 
%operations; language requirements; communications protocols; security 
%considerations; design conventions or programming standards (for example, if the 
%customer’s organization will be responsible for maintaining the delivered 
%software).$>$

The implementation of the ActivityPub federation must respect the Mastodon dialect of ActivityStreams, and be able to send/receive compatible \textit{Note} objects. Custom objects part of the platform's own ActivityStreams dialect will eventually need work to integrate with other platforms like Mastodon, but do not constitute a requirement.

To be deployed by institutions, the platform will have to support LDAP/CAS registration.

The LORIA will maintain an instance for their own use and an instance for each organization member of the OLKi project. They will constitute a prime example of the functionalities featured by the platform, and be listed on the public list of demonstration instances, even though they are production instances. A proper demonstration instance will be put up as well along them, and will have a staging role in the continuous deployment operations of the software.

\section{User Documentation}

%$<$List the user documentation components (such as user manuals, on-line help, 
%and tutorials) that will be delivered along with the software. Identify any 
%known user documentation delivery formats or standards.$>$

Along with the platform, a documentation for \begin {enumerate*} [label=\itshape\alph*\upshape)]
    \item end users,
    \item developers and
    \item system administrators
\end{enumerate*} will be deployed at \href{https://olki-docs.loria.fr}{https://olki-docs.loria.fr}. While considered both developer and third-party developer documentation, API documentation will also receive extra care and be available online.

\section{Assumptions and Dependencies}

%$<$List any assumed factors (as opposed to known facts) that could affect the 
%requirements stated in the SRS. These could include third-party or commercial 
%components that you plan to use, issues around the development or operating 
%environment, or constraints. The project could be affected if these assumptions 
%are incorrect, are not shared, or change. Also identify any dependencies the 
%project has on external factors, such as software components that you intend to 
%reuse from another project, unless they are already documented elsewhere (for 
%example, in the vision and scope document or the project plan).$>$

The OLKi platforms aims to be able to run on its own without any hard dependency to external services. However, some components that tie to external and centralised platforms like arXiv, HAL or ORTOLANG will affect its usability in case they go down or change their APIs (even though they are deemed stable since we will be \textbf{harvesting} metadata of their newest publications using OAI-PMH). In case they go down, the value of some features (i.e.: scientific watch) will be diminished but not rendered unavailable.

\chapter{External Interface Requirements}

\section{User Interfaces}

%$<$Describe the logical characteristics of each interface between the software 
%product and the users. This may include sample screen images, any GUI standards 
%or product family style guides that are to be followed, screen layout 
%constraints, standard buttons and functions (e.g., help) that will appear on 
%every screen, keyboard shortcuts, error message display standards, and so on.  
%Define the software components for which a user interface is needed. Details of 
%the user interface design should be documented in a separate user interface 
%specification.$>$

The platform will be exposed as a web service consumed by a web client in the form of a web page. A login will be required for authentified services, but part of the web interface will be usable with no account on the platform, so as to expose reference and annotation visualisation beyond simple quotes or images in conventional comments on federated third party platforms.

\section{Hardware Interfaces}

%$<$Describe the logical and physical characteristics of each interface between 
%the software product and the hardware components of the system. This may include 
%the supported device types, the nature of the data and control interactions 
%between the software and the hardware, and communication protocols to be 
%used.$>$

The platform runtime acts as a web server that binds to the loopback address on a port set by the system administrator. It answers to requests on that port only.

The platform will store files locally.

\section{Software Interfaces}

%$<$Describe the connections between this product and other specific software 
%components (name and version), including databases, operating systems, tools, 
%libraries, and integrated commercial components. Identify the data items or 
%messages coming into the system and going out and describe the purpose of each.  
%Describe the services needed and the nature of communications. Refer to 
%documents that describe detailed application programming interface protocols.  
%Identify data that will be shared across software components. If the data 
%sharing mechanism must be implemented in a specific way (for example, use of a 
%global data area in a multitasking operating system), specify this as an 
%implementation constraint.$>$

To run, the OLKi platform relies on the following external dependencies\footnote{by "external dependencies", we refer to dependencies that have to be installed by the system administrator manually when installing the application}:

\begin{itemize}
    \item PostgreSQL >= 9.6 to run the backend (model storage)
    \item Redis >= 2.8.18 to run the backend (request caching)
    \item Python >= 3.7.x to run the backend (runtime for API service)
    \item NodeJS >= 8.x to run the frontend (runtime for API consumption)
\end{itemize}

Support will be ensured for Debian stable and, if different, YunoHost stable.

\bigskip

Behaving a web server, the runtime will initiate a long-running connection to the Redis and PostgreSQL backends immediately upon start. It then answers to requests made to its local port. It is meant to be forwarded requests by a proper web server that handles TLS termination in its stead.

The platform is a long running process that is supposed to be run as a system service, of which we plan to provide service files to ease deployment.

The platform will store files locally, so any FUSE-mounted directory or remote device can be used a storage directory for files. Different storage directories are considered by type of content.

\section{Communications Interfaces}

%$<$Describe the requirements associated with any communications functions 
%required by this product, including e-mail, web browser, network server 
%communications protocols, electronic forms, and so on. Define any pertinent 
%message formatting. Identify any communication standards that will be used, such 
%as FTP or HTTP. Specify any communication security or encryption issues, data 
%transfer rates, and synchronization mechanisms.$>$

\underline{Deployment-wise}: the platform will require an e-mail account to send notification mails from. The service being an HTTP API and its web client, it will require no less than a web browser (no assumption is made as to the compatibility ensured for web browsers, but as no outstandingly modern format or feature is planned client-wise, the compatibility should be broad by default). 
The web client will communicate with the web server via the \href{https://www.w3.org/TR/activitypub/#client-to-server-interactions}{ActivityPub client} standard for social activities, and regular GraphQL operations otherwise.

\smallskip

\noindent \underline{User-wise}: the platform will require an e-mail account to send notification mails to, and a password to login with.

\section{Administration Interfaces}

Administration tasks cover functional tasks (choosing what optional functions to enable), and hybrid (functional and moderation-related) tasks like deciding who to federate with. As many tasks as possible are done from the web interface, although some might require intervention from the system administrator.

We acknowledge that while most small instances are managed by an admin user that is also the system administrator, institutional instances will see a clear distinction most of the time. We then need to allow the admin user to do most of the task, to reduce the need for the system administrator to intervene.

\section{Moderation Interfaces}

Admin user can do all moderation tasks, but moderator users dedicated to the task are desirable to reduce the load. They can \textbf{mute} or \textbf{ban} users or whole instances.

\noindent Normal users can mute or ban users or whole instances from interacting with them.

\noindent Teams can mute or ban users or whole instances from interacting with them. In that case the users in charge of a team decides for the mute and ban actions.

\bigskip

Content to be moderated can be submitted to an admin/moderator by users via \textbf{reports} if a user deems the whole instance is at risk of further interacting with the user. A report is done on an activity. Upon report the activity is pinned for moderation and placed in a \textbf{review queue}. Content uploaded by new users will also automatically be put in a review queue. The goal is to ensure new users are trustworthy.

\chapter{System Features}\label{ch:features}
%$<$This template illustrates organizing the functional requirements for the 
%product by system features, the major services provided by the product. You may 
%prefer to organize this section by use case, mode of operation, user class, 
%object class, functional hierarchy, or combinations of these, whatever makes the 
%most logical sense for your product.$>$

Completing the overview of the platform functions in section \ref{sec:functions}, we detail the main use cases the platform was designed for.

\section{Scientific Watch}

Keeping in touch with the most recent publications, a specific scientific community, and more generally getting notified about them, \emph{them} being a social group, tag (think of categories or \textbf{hashtags}), or generic \textbf{selector}.

%TODO: define what a generic selector could be

\subsection{Use Case}
%$<$List the sequences of user actions and system responses that stimulate the 
%behavior defined for this feature. These will correspond to the dialog elements 
%associated with use cases.$>$

Some scientific fields see a lot of publications daily, and keeping track of each and every single one is a tedious task. Some centralized tools aim to reduce the churn, but they are poorly integrated in our social lives. ArXiV for instance doesn't provide a conform RSS feed, a standard which is not even supported by the main centralizing social platforms.

For instance, the field of computer science has dozens of new papers daily, and filtering them with consistent tools across platforms like ArXiV or HAL could help. More than that, filtering could be done in a more sophisticated way than what these platforms offer: with a model running on metadata. That kind of tag could help researchers tune their feed to their liking.

\subsection{Functional Requirements}
%$<$Itemize the detailed functional requirements associated with this feature.  
%These are the software capabilities that must be present in order for the user 
%to carry out the services provided by the feature, or to execute the use case.  
%Include how the product should respond to anticipated error conditions or 
%invalid inputs. Requirements should be concise, complete, unambiguous, 
%verifiable, and necessary. Use “TBD” as a placeholder to indicate when necessary 
%information is not yet available.$>$
%
%$<$Each requirement should be uniquely identified with a sequence number or a 
%meaningful tag of some kind.$>$
%
%REQ-1:  REQ-2:

We note that the targeted services claim support for OAI-PMH (Open Archives Initiative Protocol for Metadata Harvesting), which allows us to harvest metadata from them via a single, standard client implementation. We also note that supporting that standard allows us to potentially harvest from 4022+ OAI conforming repositories (as of early 2019)\footnote{\url{http://www.openarchives.org/Register/BrowseSites}}.

\subsection{Description and Priority}
%$<$Provide a short description of the feature and indicate whether it is of 
%High, Medium, or Low priority. You could also include specific priority 
%component ratings, such as benefit, penalty, cost, and risk (each rated on a 
%relative scale from a low of 1 to a high of 9).$>$

The feature is deemed important to help scientific users see an immediate added value to their scientific workflow, and place the platform as a place of choice to keep visiting (even though the implementation provides interoperability with off-loading feeds to other tools of choice). It will not affect all fields of research the same, but some will definitely need such a feature to keep track of papers. It also correlates with the import of third-party metadata (also called "harvesting") and its indexation which will improve the quality of the platform's search function, so developing it will help improve the overall quality and pertinence of the platform.

\bigskip

\noindent Following other scientists and getting a private page of subscriptions sorted by query, with alerts, priority: low.

\noindent Public feed of publications, priority: high.

\section{Ease of data versioning and diffusion control}

While authoring documents is generally out of the platform's scope, updating data is something the platform has to support. Versioning data is also an option we should provide, but above all we have to enable scientists to filter how their publication is diffused, and who can see it.

\subsection{Use Case}

As it stands, publishing corpora to dedicated platforms can be a demanding action that doesn't align with the evolution of one's work: for instance, ORTOLANG forces authors to publish their datasets with a specific license and makes authors pledge to deposit their publications long term in the open, a constraint that only makes sense for finished works and is unpractical for næscent projects.

Scientists need to be able to remove their work from public listing, make it private or accessible to a restricted set of collaborators if need be. They must be able to publish their data with the license(s) they want.

\subsection{Functional Requirements}

\subsection{Description and Priority}

A detailed implementation would take time, but states (public, unlisted, private, password-protected) could be adopted early-on by the platform, so the ease of implementation justifies a medium priority.

\section{Communication around the publication}

Discussion groups and more generally comments should be available in the interface and should be easily accessible to contribute to the discussion around the publication.

\subsection{Use Case}

At first we just aim to support basic textual comments using the Mastodon dialect. The content of the comment will be able to use \LaTeX~mathematical syntax, which will be srendered when viewed in the OLKi platform web client. A specific reference syntax will be available to make references to specific files inside a Corpus (see following \textit{Note} where we assume we have a list of files being the source of a paper, and the paper itself).

\begin{minted}{json}
{
	"@context": "https://www.w3.org/ns/activitystreams",
	"@type": "Create",
	"actor": {
		"@type": "Person",
		"@id": "acct:rusnak@mastodon.example.org",
		"name": "Gene A. Rusnak"
	},
	"object": {
		"@type": "Note",
		"content": "In the recently published paper on 'Absolute Dating of Deep-Sea Cores by the Pa^231/Th^230 Method,' Rosholt, Emiliani, Geiss, Koczy, and Wangersky (1961) committed an error in their graphic representation of sediment accumulation rates base on gm/cm^2/1000 years. See file=6,7 or file=1&page=10&viewrect=50,50,640,480 and file=1&page=10&viewrect=150,150,640,480.",
		"inReplyTo": "http://olki.example.org/corpus/1",
	},
	"published": "1963-11-01T12:00:00Z"
}
\end{minted}

Of course the redaction of full \textbf{fragments} referencing parts of a \verb|.pdf| or image is difficult, and that is why the editor withing the web client will help their redaction with a visual selector. Even if they don't use that extended syntax, The main goal is for Mastodon users to be able to answer easily. They can use the same syntax as above and it will be rendered as a link when displayed by the OLKi client, or they can directly put the fully qualified link:

\begin{minted}{json}
{
"@context": "https://www.w3.org/ns/activitystreams",
	"@type": "Create",
	"actor": {
		"@type": "Person",
		"@id": "acct:rosholt@olki.example.org",
		"name": "J. N. Rosholt"
	},
	"object": {
		"@type": "Note",
		"content": "Oh, well, nobody is perfect. http://olki.example.org/corpus/1#file=6,7 ",
		"inReplyTo": "http://mastodon.example.org/note/1"
	},
	"published": "1963-11-01T12:00:01Z"
}
\end{minted}

\smallskip

Long term, supporting suggestions of modifications would be possible using \textit{Offer}, \textit{Accept} and \textit{Reject} AS activity types\footnote{\url{https://www.w3.org/TR/activitystreams-vocabulary/\#dfn-offer}}.

\smallskip

\subsection{Description}

Communicating with third-party platforms is done via interoperability in its strictest sense: servers running the OLKi platform code (also named \textbf{instances}) should be able to exchange information seamlessly so as to make a comment from a user on instance A on a dataset published on instance B viewable by users from instance A and B (modulo diffusion restrictions set by the user with publishing rights over the dataset). But more than compatibility within the network of servers running the same software, being able to exchange information (even slightly degraded) with third-party platforms like Mastodon or Pleroma allows to port activities to where users are, and allows them to answer back. This is federation intra-codebase and inter-codebases, and this is allowed by social exchanges standards like ActivityPub\footnote{\url{https://www.w3.org/TR/activitypub}} (abbreviated AP later in this document), the latest and most adopted so far.

\subsection{History of Web Federation Protocols}

But before we dive into the functional requirements involved by ActivityPub and ActivityStreams\footnote{\url{https://www.w3.org/TR/activitystreams-vocabulary/}}, let us recapitulate the past few years of federated social protocols in usage for the web (of which you can find more on \href{https://soykaf.com/post/pleroma-encyclical-activity-pub/}{lain's blog}):

Before AP, there were a few federation protocols in use already. The two largest ones are probably OStatus\footnote{\url{https://web.archive.org/web/20121008070105/http://ostatus.org/}}, the system that GNU Social (a free, libre software social platform created \emph{circa} 2010) invented, and the Diaspora protocol\footnote{\url{https://diaspora.github.io/diaspora_federation/}}. These are actually rather similar and even partially interoperable (Friendica, another free and libre platform implemented both seamlessly with little adaptation). Both essentially revolve around exchanging activity data (a post, a like, a comment) between servers. Said simply, OStatus works well for Twitter-style open communication, Diaspora works best for group-based communications (friends, acquaintances, colleagues…).

These protocols worked as expected, overall. Still, some parts of them made people look for new solutions. Especially OStatus was (and is) severely underdocumented. There is no document that you can read to implement a compatible server. Even if you read the specifications of all the standards it is made up from, you will still not know how to write a compatible server. What you have to do is to “just do what GNU Social expects”, essentially copying whatever it does while checking the existing documentation. This is an uncomfortable process that is now similarly happening in the ActivityPub realm with Mastodon leading the implementation of the protocol with its dialect.

One might argue that there was no need for ActivityPub since OStatus and Diaspora were already covering most needs. But lack of documentation (as previously mentioned) or lack or flexibility in the types of objects that can be defined, or usage of a decades-old and difficult to parse XML got the better of them and put AP right on top. While theoretically there is no technical winner, the tide has since turned in favor of ActivityPub in terms of usages and prospective of implementations.

\subsection{Functional Requirements}

Federation-wise, the use case of OLKi is close to that of another platform: PeerTube. PeerTube federates Video objects for the eponym content that constitutes the core of its purpose, and \textit{Note} objects (the name of text messages in ActivityStreams linguo) for comments that are compatible with the standard established by Mastodon dialect. In the case of OLKi, we would define a Corpus object (a collection of documents) and its associated discussions (comment threads in terms of \textit{Note} objects). Much like with PeerTube, OLKi's comments would be seen to their fullest in Mastodon but Corpus objects wouldn't be understood. Instead, they would at best be transtyped to \emph{degraded} \textit{Note} objects, again as is currently the case for PeerTube's Video objects when they reach a Mastodon instance.

\subsection{Priority}

Priority: high.

\section{Annotation of corpora and data}

While authoring documents is generally out of the platform's scope, annotating data is something the platform has to support both for a corpus's authors and its commentators.

\bigskip

\underline{Note}: special attention should be given to making annotation referenceable from non-tooled platforms via links that redirect to a proper web view. For instance, a \textit{Note} object sent to the fediverse should be openable for a detailed view of the annotation. A simple URI syntax should be given for the most simple annotation cases too.

\subsection{Use Case}

Decentralising the creation, publication, and annotation of hypertext documents provides authors with a technological guarantee for independence of any publication authority. While the platform doesn't provide authoring (creation) of documents since it focuses on hosting various types of documents, individual authors still lack the ability to conveniently engage in social interactions with documents of others in a truly decentralised fashion. With open protocols and standards for annotation, annotations can be seen as social activities and shared as such by social platforms.Such an environment provides the right technological conditions for independent publication of scientific articles, news, and other works that benefit from diverse voices and open interactions.

What can the user scenario look like? See a \texttt{.pdf} in a corpus of documents, select a few lines of text and click annoatate. Your selection is then referenced as a link put in your comment zone. You then just have to write your review in the comment section, and the comment will be sent as a textual social activity that can be seen in Mastodon and most textual federated platforms.

\subsection{Functional Requirements}



\subsection{Description and Priority}

\section{Data diffusion}

Data replication and persistence is not a goal we can achieve with full control over the data, but it is an option we should give long term so that we can provide a middle ground between having all data on the same server and offloading everything to a data warehouse with availability guarantees (CDN or long-term institutional storage). Interoperability with existing P2P protocols is envisioned, especially with the example given by Academic Torrents\footnote{\url{http://academictorrents.com}}.

\subsection{Use Case}

Big datasets might represent a heavy burden on some servers, especially non-institutional ones. They might be running the platform on a small server with limited disk space and/or bandwidth. In that case, storing the metadata and linking to a content stored elsewhere could be a proper answer.

Organising the diffusion by thinking of ressources as links stored and eventual copies served by the server will p

\subsection{Functional Requirements}

\subsection{Description and Priority}

\chapter{Other Nonfunctional Requirements}

\section{Legal Requirements}

In order to be compliant with the GDPR, the platform must respect a few points:

\begin{itemize}
	\item keep users informed about how their personal data is used.
	\item make users confirm they are above 13 (or 16?) years old upon registration.
	\item make users confirm they agree to the terms of use.
	\item keep users informed about terms of use changes (via notifications).
	\item provide tools to hide specific content terms from listings.
	\item allow users to remove all the data associated to them (corpus, comments, etc.).
	\item allow users to export that data.
\end{itemize}

\section{Performance Requirements}

%$<$If there are performance requirements for the product under various 
%circumstances, state them here and explain their rationale, to help the 
%developers understand the intent and make suitable design choices. Specify the 
%timing relationships for real time systems. Make such requirements as specific 
%as possible. You may need to state performance requirements for individual 
%functional requirements or features.$>$

The runtime is expected to run below 200MB of RAM in average, and below 500MB at peak consumption. One virtual core should be enough to deal with computations, as no heavy computation in background processes is expected (no transcoding, post-upload file transformation or machine learning).

\section{Safety Requirements}

%$<$Specify those requirements that are concerned with possible loss, damage, or 
%harm that could result from the use of the product. Define any safeguards or 
%actions that must be taken, as well as actions that must be prevented. Refer to 
%any external policies or regulations that state safety issues that affect the 
%product’s design or use. Define any safety certifications that must be 
%satisfied.$>$

No specific safety requirements apply.

\section{Security Requirements}

%$<$Specify any requirements regarding security or privacy issues surrounding use 
%of the product or protection of the data used or created by the product. Define 
%any user identity authentication requirements. Refer to any external policies or 
%regulations containing security issues that affect the product. Define any 
%security or privacy certifications that must be satisfied.$>$

The platform will not ensure TLS termination, as this is the web server's job. We will however provide guideline to configure popular web servers correctly, and ensure we properly outline what is related to security in their configuration, as well as where to update these guidelines in case of new security recommendations.

The platform must properly store the users' credentials: hashed with a password hashing function that supports salting and expensive key scheduling, such as \href{https://password-hashing.net/\#argon2}{Argon2i}. The password hashing algorithm must be resistant to side-channel attacks as the server can be a shared machine.

\section{Software Quality Attributes}
%$<$Specify any additional quality characteristics for the product that will be 
%important to either the customers or the developers. Some to consider are: 
%adaptability, availability, correctness, flexibility, interoperability, 
%maintainability, portability, reliability, reusability, robustness, testability, 
%and usability. Write these to be specific, quantitative, and verifiable when 
%possible. At the least, clarify the relative preferences for various attributes, 
%such as ease of use over ease of learning.$>$

The platform should favor interoperability over feature-completeness or fitness for the purpose. This is especially true when implementing annotations and federation, where different standards and implementations coexist. Maintainability both for the developer community (including scientists) and ease of deployment are two faces of the same problem, which should be prioritized over architecturing for performance when the gain is low, moreso than with other platforms.

Since the software should also be maintainable to some extent by scientists, and judging by the preeminence of Python-literate programmers in most computer science laboratories, Python has been selected as the implementation language of choice for the platform. Likewise, we chose the Django web framework as it provides an opinionated and very well documented set of API and countless libraries that will provide a solid basis for the project to grow.

\section{Business Rules}
%$<$List any operating principles about the product, such as which individuals or 
%roles can perform which functions under specific circumstances. These are not 
%functional requirements in themselves, but they may imply certain functional 
%requirements to enforce the rules.$>$

No business operation-specific rule has to be enforced.

\section{Deployment Requirements}\label{sec:deployment}

The application must be deployable on the latest stable version of Debian, and if possible with a YunoHost package. The goal is to make the deployment as simple as possible, even if it means pre-configuring some parameters, so that as many users and institutions can test the software, if not adopt it.

It also means updating the applications should be as seamless as possible. This imposes the use of schema migrations on the application side to describe changes in the database schema from version to version.

A checklist of deployment will be given for system administrators to check their installation matches the expected quality that the platform purports to offer (including checks for the aforementioned other nonfunctional requirements).

\chapter{Other Requirements}
%$<$Define any other requirements not covered elsewhere in the SRS. This might 
%include database requirements, internationalization requirements, legal 
%requirements, reuse objectives for the project, and so on. Add any new sections 
%that are pertinent to the project.$>$

Internationalization of the platform web client, platform backend messages and landing page has to be supported by the end of the project, and as early as possible in the project to favor external input.

\section{Appendix A: Glossary}
%see https://en.wikibooks.org/wiki/LaTeX/Glossary
%$<$Define all the terms necessary to properly interpret the SRS, including 
%acronyms and abbreviations. You may wish to build a separate glossary that spans 
%multiple projects or the entire organization, and just include terms specific to 
%a single project in each SRS.$>$

A glossary dedicated to terms related to federated social networks and their protocols can be found at the \href{URLhttps://tilde.town/~petegozz/Fediverse_Glossary/}{Fediverse Glossary} by Peter Gossner.

\begin{sortedlist}
	\sortitem[harvesting]{ \textbf{harvesting}: gathering metadata from diverse sources in an archive so that services can be built using metadata from many archives. Initially referring to a protocol permitting e-print servers to expose metadata for the papers it held in a structured fashion so other repositories could identify and copy papers of interest with each other. This protocol is now named OAI-PMH\footnote{\url{http://www.openarchives.org/OAI/openarchivesprotocol.html}}.
	}
	\sortitem[instance]{\textbf{instance}: in software engineering and web development, an instanciation of a software, generally designating the server running it and its domain. Example: "An OLKi instance" refers to a server, domain and the people running it. It is an important concept in federated networks where software is }
	\sortitem[user]{\textbf{user}: a person using the software. Unless specified, implies a registered user with an account on a platform (otherwise it is called a \textbf{visitor}).}
	\sortitem[ActivityStreams]{\textbf{ActivityStreams (AS)}: a standardization effort to define common types of objects and actions (verbs) taken on various social media sites. Quick reference to AS types and verbs}
\end{sortedlist}

\section{Appendix B: Analysis Models}
%$<$Optionally, include any pertinent analysis models, such as data flow 
%diagrams, class diagrams, state-transition diagrams, or entity-relationship 
%diagrams.$>$

\begin{center}
\begin{tikzpicture}[
any/.style={minimum width=3cm,minimum height=3cm,%
	text width=2.5cm,align=center,outer sep=0pt},
header/.style={any,minimum height=1cm,fill=black!10},
leftcol/.style={header,rotate=90},
mycolor/.style={fill=#1, text=#1!60!black}
]

\matrix (SWOT) [matrix of nodes,nodes={any,anchor=center},%
column sep=-\pgflinewidth,%
row sep=-\pgflinewidth,%
row 1/.style={nodes=header},%
column 1/.style={nodes=leftcol},
inner sep=0pt]
{
	&|[fill=helpful]| {\texta} & |[fill=harmful]| {\textb} \\
	|[fill=internal]| {\textcn} & |[mycolor=S]| \back{S} & |[mycolor=W]| \back{W} \\
	|[fill=external]| {\textdn} & |[mycolor=O]| \back{O} & |[mycolor=T]| \back{T} \\
};

\node[any, anchor=center] at (SWOT-2-2) {own platform,\\ basic annotation needs};
\node[any, anchor=center] at (SWOT-2-3) {scientific community not voicing needs,\\ adoption};
\node[any, anchor=center] at (SWOT-3-2) {existing communities\\ strong need for review tools};
\node[any, anchor=center] at (SWOT-3-3) {\\ federation dialects compatibility};

\end{tikzpicture}
\end{center}

\section{Appendix C: To Be Determined List}
%$<$Collect a numbered list of the TBD (to be determined) references that remain 
%in the SRS so they can be tracked to closure.$>$

\chapter{Project Backlog}

\begin{itemize}
	\item Users (2 months)
	\begin{todolist}
		\item User registration via CAS/LDAP/local
		\item User invites
		\item User profile
		\item User export (GDPR)
		\item User delete
		\item User upload of documents/Corpus creation
	\end{todolist}
	\item Corpus (3 months)
	\begin{todolist}
		\item Corpus page
		\item Corpus listing
		\item Corpus filtering (= basic search)
		\item Corpus commenting %TODO: reference other papers + pdf + texte + csv
		\item Corpus federated commenting
		\item Corpus federated between instances
	\end{todolist}
	\item Moderation (1 month)
	\begin{todolist}
		\item User roles
		\item User reports
		\item User quarantine
		\item User ban/mute
	\end{todolist}
	\item Federation (2 months)
	\begin{todolist}
		\item User federated profile
		\item User messages and direct messages
		\item User federated messages
		\item User federated reports
	\end{todolist}
	\item Feature: Watch (1,5 months)
	\begin{todolist}
		\item Corpus search
		\item Corpus alerts/daily/weekly
		\item User notifications (mail/AP/interface)
		\item Corpus harvesting (OAI-PMH client)
	\end{todolist}
	\item Feature: Diffusion (2 months)
	\begin{todolist}
		\item Serve feeds (RSS, OAI-PMH server)
		\item BitTorrent storage/magnet (Dat ?)
		\item Corpus versioning
		\item Password-protected views
	\end{todolist}
\end{itemize}

\end{document}
